unit Unit1;

interface

uses
  System.SysUtils, System.Types, System.UITypes, System.Classes, System.Variants,
  FMX.Types, FMX.Controls, FMX.Forms, FMX.Graphics, FMX.Dialogs,
  Androidapi.JNI.TTS, FMX.StdCtrls, FMX.Layouts, FMX.Memo, AndroidAPI.JNIBridge;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    Button1: TButton;
    Button2: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private

  type
    TttsOnInitListener = class(TJavaLocal, JTextToSpeech_OnInitListener)
    private
      [weak] FParent : TForm1;
    public
      constructor Create(AParent : TForm1);
      procedure onInit(status: Integer); cdecl;
    end;

  private
    { Private declarations }
    ttsListener : TttsOnInitListener;
    tts : JTextToSpeech;
    procedure SpeakOut;
  public
    { Public declarations }
    constructor Create(AOwner : TComponent); override;
    destructor Destroy; override;

  end;

var
  Form1: TForm1;

implementation

{$R *.fmx}

uses Androidapi.JNI.JavaTypes, FMX.Helpers.Android, Androidapi.JNI.GraphicsContentViewText;

procedure TForm1.Button1Click(Sender: TObject);
begin
  SpeakOut;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  tts := TJTextToSpeech.JavaClass.init(SharedActivityContext, ttsListener);
end;

constructor TForm1.Create(AOwner: TComponent);
begin
  inherited;
  ttsListener := TttsOnInitListener.Create(self);
end;

destructor TForm1.Destroy;
begin
  if Assigned(tts) then
  begin
    tts.stop;
    tts.shutdown;
    tts := nil;
  end;
  ttsListener := nil;
  inherited;
end;

procedure TForm1.SpeakOut;
var
  text : JString;
begin
  text := StringToJString(Memo1.Lines.Text);
  tts.speak(text, TJTextToSpeech.JavaClass.QUEUE_FLUSH, nil);
end;

{ TForm1.TttsOnInitListener }

constructor TForm1.TttsOnInitListener.Create(AParent: TForm1);
begin
  inherited Create;
  FParent := AParent
end;

procedure TForm1.TttsOnInitListener.onInit(status: Integer);
var
  Result : Integer;
begin
  if (status = TJTextToSpeech.JavaClass.SUCCESS) then
  begin
   result := FParent.tts.setLanguage(TJLocale.JavaClass.US);
   if (result = TJTextToSpeech.JavaClass.LANG_MISSING_DATA) or
      (result = TJTextToSpeech.JavaClass.LANG_NOT_SUPPORTED) then
     ShowMessage('This Language is not supported')
   else
   begin
     FParent.Button1.Enabled := true;
     FParent.button2.Enabled := false;
   end;
  end
  else
    ShowMessage('Initilization Failed!');
end;

end.
